#!/bin/bash

CSV_PATH=$1
OUTPUT_PATH=$2
REPOSITORY_TEMPLATE=$3
TESTS_FOLDER=$4
TEST_FILES_RELATIVE_PATH=$5

function print_help {
    echo Clones several existing repositories related to GitLab users and:
    echo -e "1) (Optional) Copies a repository template folder \e[1;33minto\e[0m each of them" 
    echo "2) (Optional) Copies test files into a given path within every repository"
    echo "3) Commits and pushes changes"
    echo
    echo "Usage: $0 PROJECTS_CSV_FILE OUTPUT_FOLDER [REPOSITORY_TEMPLATE | --no-repo-template] [TESTS_FOLDER TEST_FILES_RELATIVE_PATH | --no-tests]"
    echo
    echo The PROJECTS_CSV_FILE should contain data like:
    echo
    echo uid1,username1,Name1 LastName1,name1@email.com,project_id1,ssh_url1
    echo uid2,username2,Name2 LastName2,name2@email.com,project_id2,ssh_url2
    echo
    echo Typically, you want to use the output of 02_create_projects.sh
    echo
    echo The script will create OUTPUT_FOLDER. Inside it,
    echo each project will be cloned using the ssh_url.
    echo
    echo For each repository, the contents of the REPOSITORY_TEMPLATE 
    echo will be copied into it, unless --no-repo-template was specified.
    echo
    echo After that, if --no-tests argument is provided, the script will
    echo commit and push each project.
    echo
    echo If TESTS_FOLDER and TEST_FILES_RELATIVE_PATH arguments are
    echo provided instead, test files will be copied to each project
    echo before the commit and push.
    echo
    echo The TESTS_FOLDER should contain data like this:
    echo
    echo "TESTS_FOLDER/"
    echo " |"
    echo " |-- user1/"
    echo " |    |"
    echo " |    |-- tests/"
    echo " |         |"
    echo " |         |-- first_issue_test.whatever"
    echo " |         |-- second_issue_test.whatever"
    echo " |         |-- third_issue_test.whatever"
    echo " |"
    echo " |-- user2/"
    echo " |    |"
    echo 
    echo " (etc)"
    echo
    echo Typically, you want to use the \'gitlab_issues\' folder
    echo generated by 03_process_templates.sh.
    echo
    echo As you can see, it contains custom tests for each user. So, while
    echo iterating through cloned repositories, this script will copy
    echo the custom test inside the correspondent repository and make a
    echo commit and a push.
    echo
    echo -e "\e[1;33mWhere\e[0m exactly will the tests be copied?"
    echo
    echo That is up to you, to specify via TEST_FILES_RELATIVE_PATH.
    echo
    echo For instance, if the REPOSITORY_TEMPLATE goes like this:
    echo
    echo "REPOSITORY_TEMPLATE/"
    echo " |"
    echo " |-- react-introduction/"
    echo "      |"
    echo "      |-- cypress/"
    echo "      |    |"
    echo "      |    |-- integration/"
    echo "      |"
    echo "      |-- public/"
    echo "      |-- src/"
    echo
    echo ...you can specify \"react-introduction/cypress/integration\"
    echo as TEST_FILES_RELATIVE_PATH. That way, every user tests will
    echo be copied into such folder inside their repository.
    echo
    echo This allows flexibility for adding automated test files to the
    echo correct place.
}

function print_git_error_and_exit {
	echo -e "\e[1;31mERROR: \e[0mA git commit has failed. Here are some possible causes:"
	echo "- If a git commit failed, maybe git username is not correctly set or nothing was added to commit due to template files already in the repository."
	echo "- If a git push failed, maybe master is not the remote name."
	echo
	echo "We're sorry! Aborting..."
	exit
}

if [[ "$1" = "--help" || "$1" = "-h" ]]; then
	print_help
	echo
    echo -e "\e[33mVersion: \e[0m1.4.0 (12/10/2024)"
	exit 0
fi


if (( $# != 5 )); then
	if [[ $# == 4 && $4 == '--no-tests' ]]; then
		COPY_TESTS=NO
	else
		echo -e "\e[1;31mERROR: \e[0mIllegal number of parameters."
		echo
		print_help
		exit -1
	fi
fi


if [ -d "$OUTPUT_PATH" ]; then
    echo -e "\e[1;31mERROR: \e[0mOutput directory '$OUTPUT_PATH' already exists. Aborting execution to prevent overwritting it..."
    exit -1
fi

echo Creating $OUTPUT_PATH folder...
mkdir "$OUTPUT_PATH"
echo Changing to it...
cd "$OUTPUT_PATH"

echo Reading CSV file with already existing user data...
while IFS=, read -r uid username name email project_id ssh_url
do
	echo ========================================
	username=`sed -e 's/^"//' -e 's/"$//' <<<"$username"` # https://tecadmin.net/bash-remove-double-quote-string/
	ssh_url=`sed -e 's/^"//' -e 's/"$//' <<<"$ssh_url"`
	echo Creating a folder for $username and changing to it...
	mkdir $username
	cd $username
	git clone "$ssh_url"
	cd $(ls) # Change to inside repository folder.
			 # We just created the parent folder so it should be alright
    if [[ $3 == '--no-repo-template' ]]; then
		echo -e "\e[1;33mINFO:\e[0m Skipping copying any repository template because --no-repo-template option was provided"
	else
	    echo Copying repository template into $username repository...
	    cp -r ../../../$REPOSITORY_TEMPLATE/. .
	    echo -e "\e[42m[OK]\e[0m Copy is complete!"
	    git add *
	    # https://linuxhint.com/check_command_succeeded_bash/
	    git commit -m "Added initial files" && echo "Git commit done right!" || print_git_error_and_exit
    fi
	if [[ $COPY_TESTS == 'NO' ]]; then
		echo -e "\e[1;33mINFO:\e[0m Skipping copying any tests because --no-tests option was provided"
	else
		echo Copying test files... This shouldn\'t take long...
		cp -r ../../../$TESTS_FOLDER/${username}/tests/. $TEST_FILES_RELATIVE_PATH
		if [ $? -eq 0 ]; then
			echo -e "\e[42m[OK]\e[0m Tests copy is complete!"
		else
			echo -e "\e[1;31mERROR: \e[0mWe failed to copy the tests into the folder. Maybe review your TEST_FILES_RELATIVE_PATH?"
			echo Aborting execution to prevent pushing broken things...
			exit -1
		fi
		git add *
		git commit -m "Added test cases"
	fi
    if [[ $COPY_TESTS == 'NO' && $3 == '--no-repo-template' ]]; then
        echo -e "\e[42m[OK]\e[0m Everything completed. Nothing to commit or push, because both --no-repo-template and --no-tests options were provided. We have just cloned the repo!"
    else
	    git push -u origin master && echo "Git push done right!" || print_git_error_and_exit
	    echo -e "\e[42m[OK]\e[0m All copied and uploaded to repository master branch for $username"
    fi
	cd ../..

done < ../$CSV_PATH

echo -e "\e[42m[OK]\e[0m All finished. Have a nice day!"
